sub readPermissions {
	my($filename) = shift;
	my (%fields,@values);
	my ($calendar,$action,$user);
	open(IN,$filename) || &ERROR("Couldn't open permissions file: $filename");
	while(<IN>) {
		chomp;
		if (/^#format:/) {
			%fields = &ParseFormat($_);
			next;
			}
		@values = split(/\t/);
		$calendar = $values[$fields{calendar}{order}];
		$action = $values[$fields{action}{order}];
		$user = $values[$fields{user}{order}];
		$PERMISSIONS{$user}{$calendar}{$action} = 1;
		}
	close(IN);
	}

sub hasPermission {
	my ($username,$calendar,$action) = @_;
	if ($username eq "Administrator") { return 1; }
	if ($PERMISSIONS{"all"}{$calendar}{$action}) { return 1; }
	if ($PERMISSIONS{$username}{"all"}{"all"}) { return 1; }
	if ($PERMISSIONS{$username}{"all"}{$action}) { return 1; }
	if ($PERMISSIONS{$username}{$calendar}{"all"}) { return 1; }
	if ($PERMISSIONS{$username}{$calendar}{$action}) { return 1; }
	return 0;
	}
	
1;
		